package org.jboss.jsr299.tck.impl;

import javax.enterprise.context.spi.CreationalContext;

public class MockCreationalContext<T> implements CreationalContext<T>
{

   private static Object lastBeanPushed = null;
   private static boolean pushCalled = false;

   public void push(T incompleteInstance)
   {
      pushCalled = true;
      lastBeanPushed = incompleteInstance;
   }

   public static Object getLastBeanPushed()
   {
      return lastBeanPushed;
   }

   public static void setLastBeanPushed(Object lastBeanPushed)
   {
      MockCreationalContext.lastBeanPushed = lastBeanPushed;
   }

   public static boolean isPushCalled()
   {
      return pushCalled;
   }

   public static void setPushCalled(boolean pushCalled)
   {
     MockCreationalContext.pushCalled = pushCalled;
   }
   
   public static void reset()
   {
      lastBeanPushed = null;
      pushCalled = false;
   }
   
   public void release()
   {
      
   }
   

}
