package org.jboss.jsr299.tck.tests.context.dependent;

import javax.annotation.PreDestroy;
import javax.enterprise.context.Dependent;
import javax.enterprise.event.Observes;
import javax.enterprise.inject.Current;
import javax.enterprise.inject.Initializer;
import javax.enterprise.inject.spi.BeanManager;

@Dependent
class HorseStable
{
   private static boolean dependentContextActive = false;
   private static HorseStable instanceThatObservedEvent = null;
   private static boolean destroyed = false;

   @Initializer
   public HorseStable(@Current BeanManager beanManager)
   {
      dependentContextActive = beanManager.getContext(Dependent.class).isActive();
   }

   public void horseEntered(@Observes HorseInStableEvent horseEvent)
   {
      instanceThatObservedEvent = this;
   }
   
   @PreDestroy
   public void destroy()
   {
      destroyed = true;
   }

   public static boolean isDependentContextActive()
   {
      return dependentContextActive;
   }

   public static void setDependentContextActive(boolean dependentContextActive)
   {
      HorseStable.dependentContextActive = dependentContextActive;
   }

   public static HorseStable getInstanceThatObservedEvent()
   {
      return instanceThatObservedEvent;
   }
   
   public static void setInstanceThatObservedEvent(HorseStable instanceThatObservedEvent)
   {
      HorseStable.instanceThatObservedEvent = instanceThatObservedEvent;
   }
   
   public static boolean isDestroyed()
   {
      return destroyed;
   }
   
   public static void setDestroyed(boolean destroyed)
   {
      HorseStable.destroyed = destroyed;
   }
}
