package org.jboss.jsr299.tck.tests.definition.deployment.custom;

import javax.enterprise.inject.deployment.Standard;

import org.hibernate.tck.annotations.SpecAssertion;
import org.hibernate.tck.annotations.SpecAssertions;
import org.jboss.jsr299.tck.AbstractJSR299Test;
import org.jboss.testharness.impl.packaging.Artifact;
import org.jboss.testharness.impl.packaging.jsr299.BeansXml;
import org.testng.annotations.Test;

/**
 * 
 * Spec version: 20090519
 *
 */
@Artifact
@BeansXml("beans.xml")
public class CustomDeploymentTypeTest extends AbstractJSR299Test
{
   
   @SuppressWarnings("unchecked")
   @Test(groups="rewrite")
   @SpecAssertions({
      @SpecAssertion(section = "2.5.5", id = "b"),
      @SpecAssertion(section = "2.5.2", id = "d")
   })
   // Note new wording around @Standard not being explicitly needed
   public void testCustomDeploymentTypes()
   {
      assert getCurrentConfiguration().getManagers().getEnabledDeploymentTypes().size() == 3;
      assert getCurrentConfiguration().getManagers().getEnabledDeploymentTypes().get(0).equals(Standard.class);
      assert getCurrentConfiguration().getManagers().getEnabledDeploymentTypes().get(1).equals(AnotherDeploymentType.class);
      assert getCurrentConfiguration().getManagers().getEnabledDeploymentTypes().get(2).equals(HornedAnimalDeploymentType.class);
   }
   
}
