/*
 * JBoss, Home of Professional Open Source
 * Copyright 2008, Red Hat Middleware LLC, and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.jboss.jsr299.tck.tests.deployment.lifecycle;

import org.hibernate.tck.annotations.SpecAssertion;
import org.hibernate.tck.annotations.SpecAssertions;
import org.jboss.jsr299.tck.AbstractJSR299Test;
import org.jboss.testharness.impl.packaging.Artifact;
import org.testng.annotations.Test;

/**
 * Tests related to the final deployment phase of the lifecycle.
 * 
 * Spec version: 20090519 (sort of)
 *
 * PLM: THis test is a total mess and needs rewriting for 20090519 :-)
 * 
 * @author David Allen
 */
@Artifact
public class DeploymentTest extends AbstractJSR299Test
{
   @Test
   @SpecAssertion(id="unknown", section="unknown")
//   @SpecAssertions({
//      @SpecAssertion(section = "11.5.2", id = "a"),
//      @SpecAssertion(section = "11.5.3", id = "a"),
//      @SpecAssertion(section = "11.5.3", id = "d")
//   })
   public void testDeployedManagerEvent()
   {
      assert ManagerObserver.isManagerDeployed();
      getCurrentManager().fireEvent("event");
      // QUESTION what is this testing?
      assert !getCurrentManager().resolveObservers(new InitializedBinding()).isEmpty();
   }

   @Test
   @SpecAssertions({
      @SpecAssertion(section = "12.2", id = "h")
   })
   public void testScopesActive()
   {
      assert ManagerObserver.isApplicationContextActive();
      assert ManagerObserver.isRequestContextActive();
   }
   
   @Test(groups = { "ri-broken" })
   @SpecAssertions({
      @SpecAssertion(section = "11.1", id = "f")
   })
   public void testOnlyEnabledBeansDeployed()
   {
      assert !getBeans(User.class).isEmpty();
      assert getBeans(DisabledBean.class).isEmpty();
      assert getBeans(Interceptor1.class).isEmpty();
      assert getBeans(DataAccessAuthorizationDecorator.class).isEmpty();
   }
}
