package org.jboss.jsr299.tck.tests.deployment.lifecycle.broken.addDefinitionError;

import org.hibernate.tck.annotations.SpecAssertion;
import org.jboss.jsr299.tck.AbstractJSR299Test;
import org.jboss.jsr299.tck.DefinitionError;
import org.jboss.testharness.impl.packaging.Artifact;
import org.jboss.testharness.impl.packaging.ExpectedDeploymentException;
import org.testng.annotations.Test;

/**
 * Tests that any definition error added by an observer of the AfterBeanDiscovery
 * event results in a definition error.
 * 
 * Spec version: 20090519
 * 
 * @author David Allen
 * @author Dan Allen
 */
@Artifact
@ExpectedDeploymentException(DefinitionError.class)
public class AddDefinitionErrorTest extends AbstractJSR299Test
{
   @Test(groups="broken")
   @SpecAssertion(section = "11.5.2", id = "c")
   public void testObserverDefinitionErrorTreatedAsDefinitionError()
   {
      assert false;
   }
   
   // TODO make this an integration test using Extension

   // FIXME need to communicate state of container at the time of failure
   //   @Override
   //   @AfterClass(alwaysRun = true, groups = "scaffold")
   //   public void afterClass() throws Exception
   //   {
   //      super.afterClass();
   //      assert BeanDiscoveryObserver.getInvocationCount() == 2 : "All AfterBeanDiscovery observer methods should have been called";
   //   }
}
