package org.jboss.jsr299.tck.tests.deployment.lifecycle.broken.exceptionInAfterBeanDiscoveryObserver;

import org.hibernate.tck.annotations.SpecAssertion;
import org.jboss.jsr299.tck.AbstractJSR299Test;
import org.jboss.jsr299.tck.DefinitionError;
import org.jboss.testharness.impl.packaging.Artifact;
import org.jboss.testharness.impl.packaging.ExpectedDeploymentException;
import org.testng.annotations.Test;

/**
 * Tests that any exception raised in a method observing the AfterBeanDiscovery
 * event results in a definition error.
 * 
 * Spec version: 20090519
 * 
 * @author David Allen
 * @author Dan Allen
 */
@Artifact
@ExpectedDeploymentException(DefinitionError.class)
public class AfterBeanDiscoveryObserverExecutionFailureTest extends AbstractJSR299Test
{
   @Test(groups="incontainer-ri-broken")
   @SpecAssertion(section = "11.5.2", id = "d")
   public void testObserverFailureTreatedAsDefinitionError()
   {
      assert false;
   }
}