package org.jboss.jsr299.tck.tests.event;

public class MagicString
{
   private static boolean equalsUsed = false;
   private final String   value;

   public MagicString(String value)
   {
      this.value = value;
   }

   public int compareTo(String anotherString)
   {
      return value.compareTo(anotherString);
   }

   public int compareToIgnoreCase(String str)
   {
      return value.compareToIgnoreCase(str);
   }

   @Override
   public boolean equals(Object anObject)
   {
      return value.equals(anObject);
   }

   @Override
   public int hashCode()
   {
      return value.hashCode();
   }

   public boolean isEmpty()
   {
      return value == null || value.length() == 0;
   }

   public int length()
   {
      return value.length();
   }

   public boolean matches(String regex)
   {
      return value.matches(regex);
   }

   public static boolean isEqualsUsed()
   {
      return equalsUsed;
   }
}
