package org.jboss.jsr299.tck.tests.event.implicit;

import javax.enterprise.event.Event;
import javax.enterprise.inject.Any;
import javax.enterprise.inject.Initializer;

class Registration
{
   private @Any Event<StudentRegisteredEvent> studentRegisteredEvent;
   
   private Event<CourseFullEvent> courseFullEvent;
   
   // FIXME @Any should not be required here
   public @Initializer Registration(@Any Event<CourseFullEvent> courseFullEvent)
   {
      this.courseFullEvent = courseFullEvent;
   }
   
   public void registerUser(Student student)
   {
      studentRegisteredEvent.fire(new StudentRegisteredEvent(student));
   }
   
   public void registerForCourse(Course course, Student user)
   {
      courseFullEvent.fire(new CourseFullEvent(course));
   }
   
   Event<CourseFullEvent> getCourseFullEvent()
   {
      return courseFullEvent;
   }
}
