package org.jboss.jsr299.tck.tests.event.resolve.binding;

import java.util.Set;

import javax.enterprise.event.Observer;

import org.hibernate.tck.annotations.SpecAssertion;
import org.hibernate.tck.annotations.SpecAssertions;
import org.jboss.jsr299.tck.AbstractJSR299Test;
import org.jboss.testharness.impl.packaging.Artifact;
import org.testng.annotations.Test;

/**
 * Spec version: 20090519
 */
@Artifact
public class ResolvingChecksBindingTypeMembersTest extends AbstractJSR299Test
{
   public static class AnEventType
   {
   }

   public static class AnObserver implements Observer<AnEventType>
   {
      public boolean wasNotified = false;

      public boolean notify(AnEventType event)
      {
         wasNotified = true;
         return false;
      }
   }

   @Test(groups = { "events" })
   @SpecAssertions({
      @SpecAssertion(section = "10.5.1", id = "a"),
      @SpecAssertion(section = "10.2.1", id = "a"),
      @SpecAssertion(section = "10.2.1", id = "b")
   })
   public void testResolvingChecksBindingTypeMembers()
   {
      AnObserver observer = new AnObserver();
      AnObserver anotherObserver = new AnObserver();
      getCurrentManager().addObserver(observer, new BindingTypeCBinding("first-observer"));
      getCurrentManager().addObserver(anotherObserver, new BindingTypeCBinding("second-observer"));
      Set<Observer<AnEventType>> resolvedObservers = getCurrentManager().resolveObservers(new AnEventType(), new BindingTypeCBinding("first-observer"));
      assert resolvedObservers.size() == 1;
      resolvedObservers = getCurrentManager().resolveObservers(new AnEventType(), new BindingTypeCBinding("second-observer"));
      assert resolvedObservers.size() == 1;
   }
}
