package org.jboss.jsr299.tck.tests.event.resolve.typeFamily;

import org.hibernate.tck.annotations.SpecAssertion;
import org.jboss.jsr299.tck.AbstractJSR299Test;
import org.jboss.testharness.impl.packaging.Artifact;
import org.testng.annotations.Test;

/**
 * Spec version: 20090519
 */
@Artifact
public class AllEventTypesTest extends AbstractJSR299Test
{
   @Test(groups = { "events" })
   @SpecAssertion(section = "10.1", id = "c")
   public void testEventTypeIncludesAllSuperclassesAndInterfacesOfEventObject() throws Exception
   {
      // Fire a single complex type of event with many observers
      new RunInDependentContext()
      {
         @Override
         protected void execute() throws Exception
         {
            AllEventTypesObserver theObserver = getInstanceByType(AllEventTypesObserver.class);
            getCurrentManager().fireEvent(new ComplexEvent());
            assert theObserver.getTotalEventsObserved() == 4;
         }

      }.run();
   }
}
