package org.jboss.jsr299.tck.tests.event.resolve.typeWithParameters;

import java.util.Set;

import javax.enterprise.event.Observer;

import org.hibernate.tck.annotations.SpecAssertion;
import org.jboss.jsr299.tck.AbstractJSR299Test;
import org.jboss.testharness.impl.packaging.Artifact;
import org.testng.annotations.Test;

/**
 * Spec version: 20090519
 */
@Artifact
public class ChecksEventTypeWhenResolvingTest extends AbstractJSR299Test
{
   public static class AnEventType
   {
   }

   public static class AnObserver implements Observer<AnEventType>
   {
      public boolean wasNotified = false;

      public boolean notify(AnEventType event)
      {
         wasNotified = true;
         return false;
      }
   }

   @Test(groups = { "events" })
   @SpecAssertion(section = "10.5.1", id = "a")
   public void testResolvingChecksEventType()
   {
      Observer<AnEventType> observer = new AnObserver();
      getCurrentManager().addObserver(observer);
      Set<Observer<AnEventType>> resolvedObservers = getCurrentManager().resolveObservers(new AnEventType());
      assert !resolvedObservers.isEmpty();
      Set<?> emptyObserverSet = getCurrentManager().resolveObservers(new UnusedEventType("name"));
      assert emptyObserverSet.isEmpty();
   }
}
