package org.jboss.jsr299.tck.tests.implementation.disposal.method.definition;

import javax.enterprise.inject.Current;
import javax.enterprise.inject.Disposes;
import javax.enterprise.inject.Produces;

@AnotherDeploymentType
class SpiderProducer
{
   private static boolean tameSpiderDestroyed = false;
   private static boolean currentSpiderDestroyed = false;
   private static boolean deadliestSpiderDestroyed = false;

   @Produces public Tarantula produceTarantula()
   {
      return new Tarantula();
   }
   
   @Produces @Tame public Tarantula produceTameTarantula()
   {
      return new DefangedTarantula();
   }
   
   @Produces @Deadliest public Tarantula producesDeadliestTarantula(@Tame Tarantula tameTarantula, 
         @Current Tarantula tarantula)
   {      
      return tameTarantula.getDeathsCaused() >= tarantula.getDeathsCaused() ?
            tameTarantula : tarantula;
   }
   
   public void destroyTameSpider(@Disposes @Tame Tarantula spider)
   {
      SpiderProducer.tameSpiderDestroyed = true;
   }
   
   public static void destroyCurrentSpider(@Disposes @Current Tarantula spider)
   {
      SpiderProducer.currentSpiderDestroyed = true;
   }

   public static void destroyDeadliestSpider(@Disposes @Deadliest Tarantula spider, @Current Tarantula anotherSpider)
   {
      assert spider != anotherSpider;
      SpiderProducer.deadliestSpiderDestroyed = true;
   }

   public static boolean isTameSpiderDestroyed()
   {
      return tameSpiderDestroyed;
   }

   public static boolean isCurrentSpiderDestroyed()
   {
      return currentSpiderDestroyed;
   }

   public static boolean isDeadliestSpiderDestroyed()
   {
      return deadliestSpiderDestroyed;
   }
}
