package org.jboss.jsr299.tck.tests.implementation.enterprise.broken.newAndOtherBinding;


import org.hibernate.tck.annotations.SpecAssertion;
import org.jboss.jsr299.tck.AbstractJSR299Test;
import org.jboss.jsr299.tck.DefinitionError;
import org.jboss.testharness.impl.packaging.Artifact;
import org.jboss.testharness.impl.packaging.ExpectedDeploymentException;
import org.testng.annotations.Test;

@Artifact
@ExpectedDeploymentException(DefinitionError.class)
public class NewAndOtherBindingTest extends AbstractJSR299Test
{
   

   /**
    * If the @New binding type appears in conjunction with some other binding
    * type, or is specified for a field or parameter of a type which does not
    * satisfy the definition of a simple Web Bean implementation class or
    * enterprise Web Bean implementation class, a DefinitionException is thrown
    * by the container at deployment time.
    */
   @Test(groups = { "new", "stub" })
   //Remove from stub group if this test must be executed; otherwise, we should not be running it
   @SpecAssertion(section = "review", id = "review")
   public void testNewAnnotationCannotAppearInConjunctionWithOtherBindingType()
   {
      assert false;
   }
   
}
