package org.jboss.jsr299.tck.tests.implementation.enterprise.remove;

import javax.annotation.PreDestroy;
import javax.ejb.Remove;
import javax.ejb.Stateful;
import javax.enterprise.inject.Current;
import javax.enterprise.inject.spi.BeanManager;

@Stateful
public class DependentSessionBean implements DependentSessionInterface
{
   @Current
   private StateKeeper stateKeeper;

   @Remove
   public void remove()
   {
      stateKeeper.setRemoveCalled(true);
   }

   @Remove
   public void anotherRemoveWithParameters(String reason, @Current BeanManager manager)
   {
      stateKeeper.setRemoveCalled(true);
      assert manager == null;
   }

   @PreDestroy
   public void markDestroyed()
   {
      stateKeeper.setBeanDestroyed(true);
   }

   public void businessMethod()
   {
   }
}
