package org.jboss.jsr299.tck.tests.implementation.initializer;

import org.hibernate.tck.annotations.SpecAssertion;
import org.hibernate.tck.annotations.SpecAssertions;
import org.jboss.jsr299.tck.AbstractJSR299Test;
import org.jboss.testharness.impl.packaging.Artifact;
import org.jboss.testharness.impl.packaging.Packaging;
import org.jboss.testharness.impl.packaging.PackagingType;
import org.testng.annotations.Test;

/**
 * 
 * Spec version: 20090519
 */
@Artifact
@Packaging(PackagingType.EAR)
public class InitializerMethodTest extends AbstractJSR299Test
{

   @Test(groups = { "initializerMethod" })
   @SpecAssertions({
      @SpecAssertion(section = "3.9.2", id = "b")
   })
   public void testBindingTypeOnInitializerParameter()
   {
      PremiumChickenHutch hutch = getInstanceByType(PremiumChickenHutch.class);
      assert hutch.getChicken().getName().equals("Preferred");
      StandardChickenHutch anotherHutch = getInstanceByType(StandardChickenHutch.class);
      assert anotherHutch.getChicken().getName().equals("Standard");
   }

   @Test(groups = { "stub", "initializerMethod", "interceptors" })
   @SpecAssertion(section = "3.9", id = "f")
   public void testMethodInterceptorNotCalledOnInitializerMethod()
   {
      assert false;
   }

   @Test(groups = { "initializerMethod" })
   @SpecAssertions({ 
      @SpecAssertion(section = "3.9", id = "g"), 
      @SpecAssertion(section = "5.3", id = "b"),
      @SpecAssertion(section = "3.9.1", id = "a"),
      @SpecAssertion(section = "3.9.2", id = "aa")
   })
   public void testMultipleInitializerMethodsAreCalled()
   {
      ChickenHutch chickenHutch = getInstanceByType(ChickenHutch.class);
      assert chickenHutch.fox != null;
      assert chickenHutch.chicken != null;
   }

}