package org.jboss.jsr299.tck.tests.implementation.simple.newSimpleBean;

import java.io.Serializable;

import javax.enterprise.context.SessionScoped;
import javax.enterprise.inject.Current;
import javax.enterprise.inject.Initializer;
import javax.enterprise.inject.Named;

@SessionScoped
@Named("Charlie")
class InitializerSimpleBean implements Serializable
{
   private static final long serialVersionUID = 1L;
   private static int        initializerCalls = 0;

   @Current
   protected Order           order;

   @Initializer
   public void initializer()
   {
      initializerCalls++;
   }

   public void businessMethod()
   {
      
   }

   public static int getInitializerCalls()
   {
      return initializerCalls;
   }

   public static void setInitializerCalls(int initializerCalls)
   {
      InitializerSimpleBean.initializerCalls = initializerCalls;
   }
}
