package org.jboss.jsr299.tck.tests.implementation.simple.resource.persistenceContext;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.PersistenceContext;
import javax.persistence.PersistenceUnit;

class SimpleBean
{
   @PersistenceContext
   private EntityManager        persistenceContext;
   private boolean              persistenceContextExistsDuringConstruction;

   @PersistenceUnit
   private EntityManagerFactory persistenceUnit;
   private boolean              persistenceUnitExistsDuringConstruction;

   public SimpleBean()
   {
      persistenceContextExistsDuringConstruction = persistenceContext != null;
      persistenceUnitExistsDuringConstruction = persistenceUnit != null;
   }

   public EntityManager getPersistenceContext()
   {
      return persistenceContext;
   }

   public EntityManagerFactory getPersistenceUnit()
   {
      return persistenceUnit;
   }

   public boolean isPersistenceContextExistsDuringConstruction()
   {
      return persistenceContextExistsDuringConstruction;
   }

   public boolean isPersistenceUnitExistsDuringConstruction()
   {
      return persistenceUnitExistsDuringConstruction;
   }
}
