package org.jboss.jsr299.tck.tests.implementation.simple.resource.resource;

import javax.enterprise.context.spi.CreationalContext;
import javax.enterprise.inject.spi.Bean;
import javax.enterprise.inject.spi.BeanManager;

import org.hibernate.tck.annotations.SpecAssertion;
import org.jboss.jsr299.tck.AbstractJSR299Test;
import org.jboss.testharness.impl.packaging.Artifact;
import org.jboss.testharness.impl.packaging.IntegrationTest;
import org.jboss.testharness.impl.packaging.Packaging;
import org.jboss.testharness.impl.packaging.PackagingType;
import org.jboss.testharness.impl.packaging.jsr299.BeansXml;
import org.testng.annotations.Test;

/**
 * 
 * Spec version: 20090519
 *
 */
@Artifact
@Packaging(PackagingType.WAR)
@IntegrationTest
@BeansXml("beans.xml")
public class InjectionOfResourceTest extends AbstractJSR299Test
{
   @Test(groups = { "ri-broken", "beanLifecycle", "commonAnnotations", "integration" })
   @SpecAssertion(section = "3.6.1", id = "bb")
   public void testInjectionOfResource()
   {
      Bean<SimpleBean> simpleBeanBean = getBeans(SimpleBean.class).iterator().next();
      CreationalContext<SimpleBean> creationalContext = getCurrentManager().createCreationalContext(simpleBeanBean);
      SimpleBean simpleBean = simpleBeanBean.create(creationalContext);
      BeanManager beanManager = simpleBean.getManager();
      assert !simpleBean.isManagerInjected() : "Manager injected too early";
      assert beanManager != null : "@Another Manager not found";
      assert beanManager.equals(getCurrentManager()): "Wrong manager found";
   }
}
