package org.jboss.jsr299.tck.tests.inheritance.specialization.enterprise;

import java.lang.annotation.Annotation;

import javax.enterprise.inject.AnnotationLiteral;

import org.hibernate.tck.annotations.SpecAssertion;
import org.hibernate.tck.annotations.SpecAssertions;
import org.jboss.jsr299.tck.AbstractJSR299Test;
import org.jboss.testharness.impl.packaging.Artifact;
import org.jboss.testharness.impl.packaging.IntegrationTest;
import org.jboss.testharness.impl.packaging.Packaging;
import org.jboss.testharness.impl.packaging.PackagingType;
import org.jboss.testharness.impl.packaging.jsr299.BeansXml;
import org.testng.annotations.Test;

@Artifact
@IntegrationTest
@Packaging(PackagingType.EAR)
@BeansXml("beans.xml")
public class EnterpriseBeanSpecializationIntegrationTest extends AbstractJSR299Test
{
   
   private static Annotation LANDOWNER_LITERAL = new AnnotationLiteral<Landowner>() {};
   
   @Test
   @SpecAssertions({
     @SpecAssertion(section = "4.3.1", id = "f"),
     @SpecAssertion(section = "3.3.7", id = "b"),
     @SpecAssertion(section = "3.3.7", id = "c")
   })
   public void testSpecializedBeanNotInstantiated() throws Exception
   {
      new RunInDependentContext()
      {
         
         @Override
         protected void execute() throws Exception
         {
            FarmerLocal farmer = getInstanceByType(FarmerLocal.class,LANDOWNER_LITERAL);
            assert farmer.getClassName().equals(LazyFarmer.class.getName());
         }
         
      }.run();
   }
   
   
   @Test
   @SpecAssertion(section="4.3.1", id = "g")
   public void testProducerMethodOnSpecializedBeanCalledOnSpecializingBean() throws Exception
   {
      new RunInDependentContext()
      {
         
         @Override
         protected void execute() throws Exception
         {
            assert getBeans(Waste.class).size() == 1;
            assert getInstanceByType(Waste.class).getFrom().equals(Office.class.getName());
         }
         
      }.run();
   }
}
