package org.jboss.jsr299.tck.tests.inheritance.specialization.producer.method;

import java.lang.annotation.Annotation;

import javax.enterprise.inject.AnnotationLiteral;
import javax.enterprise.inject.Any;

import org.hibernate.tck.annotations.SpecAssertion;
import org.hibernate.tck.annotations.SpecAssertions;
import org.jboss.jsr299.tck.AbstractJSR299Test;
import org.jboss.testharness.impl.packaging.Artifact;
import org.jboss.testharness.impl.packaging.jsr299.BeansXml;
import org.testng.annotations.Test;

/**
 * Spec version: 20090519
 * 
 */
@Artifact
@BeansXml("beans.xml")
public class ProducerMethodSpecializationTest extends AbstractJSR299Test
{
   
   private static Annotation EXPENSIVE_LITERAL = new AnnotationLiteral<Expensive>() {};

   @Test
   @SpecAssertions({
     @SpecAssertion(section = "3.4.4", id = "aa")
   })
   public void testSpecializingBeanHasBindingsOfSpecializedAndSpecializingBean() throws Exception
   {
      assert getCurrentManager().getBeans(Product.class, EXPENSIVE_LITERAL).size() == 1;
      assert getCurrentManager().getBeans(Product.class, EXPENSIVE_LITERAL).iterator().next().getBindings().size() == 3;
      assert annotationSetMatches( getCurrentManager().getBeans(Product.class, EXPENSIVE_LITERAL).iterator().next().getBindings(), Expensive.class, Sparkly.class, Any.class);
      assert getBeans(Product.class, new AnnotationLiteral<Sparkly>(){}).size() == 1;
      assert getBeans(Product.class, new AnnotationLiteral<Sparkly>(){}).iterator().next().getName().equals("expensiveGift");
      new RunInDependentContext()
      {
         
         @Override
         protected void execute() throws Exception
         {
            Product product = getInstanceByType(Product.class,EXPENSIVE_LITERAL);
            assert product instanceof Necklace;
         }
         
      }.run();
   }
   
}
