package org.jboss.jsr299.tck.tests.lookup.el;

import javax.enterprise.context.Conversation;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.context.spi.Context;
import javax.enterprise.inject.spi.Bean;

import org.hibernate.tck.annotations.SpecAssertion;
import org.hibernate.tck.annotations.SpecAssertions;
import org.jboss.jsr299.tck.AbstractJSR299Test;
import org.jboss.testharness.impl.packaging.Artifact;
import org.testng.annotations.Test;

/**
 * 
 * Spec version: 20090519
 *
 */
@Artifact
public class ResolutionByNameTest extends AbstractJSR299Test
{
   
   @Test(groups={"stub", "el"})  @SpecAssertion(section="5.6", id = "aba")
   public void testELResolverRegisteredWithJsf()
   {
      assert false;
   }
   
   @Test(groups={"stub", "el"})  @SpecAssertion(section="5.6", id = "aaa")
   public void testELResolverRegisteredWithServlet()
   {
      assert false;
   }
   
   @Test
   @SpecAssertion(section="5.6", id="c")
   public void testQualifiedNameLookup()
   {
      assert getCurrentConfiguration().getEl().evaluateValueExpression("#{javax.context.conversation}", Conversation.class) != null;
      assert getCurrentConfiguration().getEl().evaluateValueExpression("#{javax.context.conversation}", Conversation.class) instanceof Conversation;
   }

   @Test(groups = "beanLifecycle")
   @SpecAssertions({
      @SpecAssertion(section = "5.6", id = "bc"),
      @SpecAssertion(section = "6.5.2", id = "a")
   })
   public void testContextCreatesNewInstanceForInjection()
   {
      Context requestContext = getCurrentManager().getContext(RequestScoped.class);
      Bean<Tuna> tunaBean = getBeans(Tuna.class).iterator().next();
      assert requestContext.get(tunaBean) == null;
      TunaFarm tunaFarm = getCurrentConfiguration().getEl().evaluateValueExpression("#{tunaFarm}", TunaFarm.class);
      assert tunaFarm.tuna != null;
   }

}
